<html>
<head>
<link rel='stylesheet' type='text/css' href='style.css'>
</head>

<body>
<?php
# Variable Definitions
$comtype = "qemu+tcp";
$dnsdomain = "yourdomain.tld";
$arr_hosts = array('host1','host2','host3');
$colors = array ('active' => "LightGreen", 'inactive' => "LightGrey", 'title' => 'LightYellow', 'warning' => 'Red');
$reverse = 0;
?>

<?php

## Function to get and display domains
function get_domains($host,$dnsdomain,$comtype) {
  $conn = @libvirt_connect($comtype . '://' . $host . '.' . $dnsdomain . '/system', true);
  if (! $conn) { 
    return false;
  }
  $aa_domains = array();
  foreach ( libvirt_list_domain_resources($conn) as $domres ) { ;
    $arr_values = array();
    $arr_domain = array();
    $domxml = libvirt_domain_get_xml_desc($domres,NULL);
    $res_xmlparser = xml_parser_create("UTF-8");
    xml_parse_into_struct($res_xmlparser, $domxml, $arr_values);
    $num_disk=0;
    $num_intf=0;
    foreach ($arr_values as $element) {
      if (($element['tag'] == "DOMAIN") && ($element['type'] == "open")) {
        $parent = "domain";
      }
      if (($element['tag'] == "DISK") && ($element['type'] == "open")) {
        $parent="disk";
        $num_disk++;
        $arr_domain['disk'][$num_disk]['src'] = "(missing)";
        $arr_domain['disk'][$num_disk]['tgt'] = "(missing)";
        $arr_domain['disk'][$num_disk]['type'] = $element['attributes']['TYPE'];
        
      }
      if (($element['tag'] == "INTERFACE") && ($element['type'] == "open")) {
        $parent="interface";
        $num_intf++;
        $arr_domain['net'][$num_intf]['src'] = "(missing)";
        $arr_domain['net'][$num_intf]['tgt'] = "(missing)";
        $arr_domain['net'][$num_intf]['type'] = $element['attributes']['TYPE'];
      }
      if (($element['tag'] == "SERIAL") && ($element['type'] == "open")) {
        $parent="serial";
      }
      if (($element['tag'] == "INPUT") && ($element['type'] == "open")) {
        $parent="input";
      }
      if (($element['tag'] == "VIDEO") && ($element['type'] == "open")) {
        $parent="video";
      }
      if (($element['tag'] == "MEMBALLOON") && ($element['type'] == "open")) {
        $parent="memballoon";
      }
        if ($element['tag'] == "NAME") {
        $arr_domain['name'] = $element['value'];
      }
      if ($element['tag'] == "DESCRIPTION") {
        $arr_domain['desc'] = $element['value'];
      }
      if ($element['tag'] == "MEMORY") {
        $arr_domain['allocmem'] = $element['value'];
      }
      if ($element['tag'] == "CURRENTMEMORY") {
        $arr_domain['currmem'] = $element['value'];
      }
      if ($element['tag'] == "VCPU") {
        $arr_domain['vcpu'] = $element['value'];
      }
      if (($element['tag'] == "SOURCE") && ($parent=="disk")) {
       $arr_domain['disk'][$num_disk]['src'] = $element['attributes']['DEV'] . $element['attributes']['FILE'];
      }
      if (($element['tag'] == "TARGET") && ($parent=="disk")) {
        $arr_domain['disk'][$num_disk]['tgt'] = $element['attributes']['DEV'];
      }
      if (($element['tag'] == "SOURCE") && ($parent=="interface")) {
        $arr_domain['net'][$num_intf]['src'] = $element['attributes']['BRIDGE'] . $element['attributes']['NETWORK'];
      }
      if (($element['tag'] == "TARGET") && ($parent=="interface")) {
        $arr_domain['net'][$num_intf]['tgt'] = $element['attributes']['DEV'];
      }
      if ($element['tag'] == "GRAPHICS") {
        $arr_domain['vncport'] = $element['attributes']['PORT'];
      }
   }
    $arr_domain['isactive'] = libvirt_domain_is_active($domres);
    $arr_domain['host'] = $host;
    $arr_domain['id'] = libvirt_domain_get_id($domres);

    array_push($aa_domains, $arr_domain);
  }
  return $aa_domains;
}

## Main

$prevsort=$_GET['sort'];

if ($_GET['reverse']) {
  $reverse=$_GET['reverse'];
}

if ($_GET['sort']) {
  $sortkey = $_GET['sort'];
} else {
  $sortkey = "name";
}

if ($_GET['prevsort'] == $sortkey) {
  if ($reverse == 1) {
    $reverse = 0;
  } else {
    $reverse = 1;
  }
}

if ($_GET['op'] != "") {
  echo "Selected Operation: " . $_GET['op'] . ", Resource: " . $_GET['domid'];
}
?>

<h1>Virtual Infrastructure Overview</h1>

<form name="selection" action="<?echo $_SERVER['PHP_SELF']?>" method="get">
<p>
<input type="radio" name="visibility" value="all"<?if ($_GET['visibility'] != "checked") { echo 'checked="checked"'; }?> onclick = document.selection.submit();> All VMs<br>
<input type="radio" name="visibility" value="running" <?if ($_GET['visibility'] == "running") { echo 'checked="checked"'; }?> onclick = document.selection.submit();> Only running VMs<br>
</p>
</form>

<table border="1" cellspacing="0" cellpadding="4" style="empty-cells:show" >
<tr>
<th align="Left" bgcolor="<?echo $colors['title']?>"><a href="<?echo $_SERVER['PHP_SELF'] . '?sort=name&prevsort=' . $prevsort . '&reverse=' . $reverse . '&visibility=' . $_GET['visibility']?>"<?if ($sortkey == "name") { ?> class="active"<? } ?>>VM</a></th>
<th  bgcolor="<?echo $colors['title']?>"><a href="<?echo $_SERVER['PHP_SELF'] . '?sort=desc&prevsort=' . $prevsort . '&reverse=' . $reverse . '&visibility=' . $_GET['visibility']?>"<?if ($sortkey == "desc") {?> class="active"<? } ?>>Description</a></th>
<th  bgcolor="<?echo $colors['title']?>"><a href="<?echo $_SERVER['PHP_SELF'] . '?sort=host&prevsort=' . $prevsort . '&reverse=' . $reverse . '&visibility=' . $_GET['visibility']?>"<?if ($sortkey == "host") {?>class="active"<? } ?>>Carrier</a></th>
<th  bgcolor="<?echo $colors['title']?>"><a href="<?echo $_SERVER['PHP_SELF'] . '?sort=allocmem&prevsort=' . $prevsort . '&reverse=' . $reverse . '&visibility=' . $_GET['visibility']?>" <?if ($sortkey == "allocmem") {?>class="active"<? } ?>>Allocated Memory</a></th>
<th  bgcolor="<?echo $colors['title']?>"><a href="<?echo $_SERVER['PHP_SELF'] . '?sort=currmem&prevsort=' . $prevsort . '&reverse=' . $reverse . '&visibility=' . $_GET['visibility']?>" <?if ($sortkey == "currmem") {?>class="active"<? } ?>>Current Memory</a></th>
<th  bgcolor="<?echo $colors['title']?>"><a href="<?echo $_SERVER['PHP_SELF'] . '?sort=vcpu&prevsort=' . $prevsort . '&reverse=' . $reverse . '&visibility=' . $_GET['visibility']?>" <?if ($sortkey == "vcpu") {?>class="active"<? } ?>># CPU</a></th>
<th  bgcolor="<?echo $colors['title']?>"><a href="<?echo $_SERVER['PHP_SELF'] . '?sort=disktype&prevsort=' . $prevsort . '&reverse=' . $reverse . '&visibility=' . $_GET['visibility']?>" <?if ($sortkey == "disktype") {?>class="active"<? } ?>>Disk</a><table width=100%><th width="50px" align="Left">Type</th><th width="350px" align="left">Source</th><th width="50px" align="left">Target</th></table></th>
<th  bgcolor="<?echo $colors['title']?>"><a href="<?echo $_SERVER['PHP_SELF'] . '?sort=nettype&prevsort=' . $prevsort . '&reverse=' . $reverse . '&visibility=' . $_GET['visibility']?>" <?if ($sortkey == "nettype") {?>class="active"<? } ?>>Network</a><table width=100%><th width="80px" align="Left">Type</th><th width="80px" align="left">Source</th><th width="50px" align="left">Target</th></table></th>
<th  bgcolor="<?echo $colors['title']?>"><a href="<?echo $_SERVER['PHP_SELF'] . '?sort=vncport&prevsort=' . $prevsort . '&reverse=' . $reverse . '&visibility=' . $_GET['visibility']?>" <?if ($sortkey == "vncport") {?>class="active"<? } ?>>VNC Port</a></th>
<th  bgcolor="<?echo $colors['title']?>"><a href="<?echo $_SERVER['PHP_SELF'] . '?sort=isactive&prevsort=' . $prevsort . '&reverse=' . $reverse . '&visibility=' . $_GET['visibility']?>" <?if ($sortkey == "isactive") {?>class="active"<? } ?>>Running</a></th>
</tr>

<?php
$aa_domains = array();
# Go through hosts
foreach ( $arr_hosts as $host ) {
  $aa_hostdomains = get_domains($host,$dnsdomain,$comtype);
  if (! $aa_hostdomains) {
     echo "<p><font color=" . $colors['warning'] . ">Warning: Host <b>" . $host . "</b> not reachable!<font></p>";
    continue;
  }
  $aa_domains = array_merge($aa_domains,$aa_hostdomains);
}

# Sort by selected criteria
$aa_index = array();
foreach ($aa_domains as $key => $arr_domain) {
  if ( !is_array($aa_index[$arr_domain[$sortkey]]) ) {
    $aa_index[$arr_domain[$sortkey]] = array();
  }
  array_push($aa_index[$arr_domain[$sortkey]],$key);
}

# Sorting index
if ($reverse == 0) {
  ksort($aa_index);  
} else {
  krsort($aa_index);
}

foreach ($aa_index as $arr_index) {
  foreach ($arr_index as $key_domain) {
    $arr_domain = $aa_domains[$key_domain];
    if ($arr_domain['isactive']) {
      $color = $colors['active'];
      $running = "yes";
    } else {
      if ($_GET['visibility'] == "running") {
        continue;
      } else {
        $color = $colors['inactive'];;
        $running = "no";
      }
    }
    ?>
   <tr bgcolor='<?echo $color;?>'>
      <td valign=top><?echo $arr_domain['name']?></td>
      <td valign=top><?echo $arr_domain['desc']?></td>
      <td valign=top><?echo $arr_domain['host']?></td>
      <td valign=top><?echo $arr_domain['allocmem']?></td>
      <td valign=top><?echo $arr_domain['currmem']?></td>
      <td valign=top><?echo $arr_domain['vcpu']?></td>
      <td valign=top>
        <table border=0 cellspacing="0" cellpadding="0" style="empty-cells:show" width=100%>
        <?foreach ($arr_domain['disk'] as $element) {
          echo "<tr>";
          echo "<td valign=top width=50px>" . $element['type'] . "</td>";
          echo "<td valign=top width=300px>" . $element['src'] . "</td>";
          echo "<td valign=top width=50px>" . $element['tgt'] . "</td>";
          echo "</tr>";
        }?>
        </table>
      </td>
      <td valign=top>
        <table border=0 cellspacing="0" cellpadding="0" style="empty-cells:show" width=100%>
        <?foreach ($arr_domain['net'] as $element) {
          echo "<tr>";
          echo "<td valign=top width=80px>" . $element['type'] . "</td>";
          echo "<td valign=top width=80px>" . $element['src'] . "</td>";
          echo "<td valign=top width=50px>" . $element['tgt'] . "</td>";
          echo "</tr>";
        }?>
        </table>
      </td>
      <td valign=top><?echo $arr_domain['vncport']?></td>
      <td valign=top><?echo $running?></td>
    </tr>
    <?
  }
}
?>
</table>
</body>
</html>
